/* more just a misc. example of how things can go wrong when relying on variables state (without explicitly clearing/initializing its data correctly) */
/* mercy@felinemenace.org */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <unistd.h>


char msg[] = "This is my trusted test message";

int main(int argc, char **argv)
{
	char *f1 = NULL;
	char buffer[sizeof(msg)];

	if(argc <= 1) {
		fprintf(stdout, "Usage: %s [message]\n", argv[0]);
		exit(-1);
	}

	f1 = malloc(100);
	memset(f1, 0x00, 100);   // <-- good!! this doesnt rely on f1's state being clean.
	memcpy(f1, argv[1], 100);
	free(f1); // <-- this does not clear the data @f1, instead it just free's the chunk.

	f1 = malloc(100);  // <-- this should allocate over the top of the previous f1 chunk
	strncpy(f1, msg, strlen(msg));  // <-- write into the f1 chunk the trusted message (relies on NULL terminate already ;))

	sprintf(buffer, "%s", f1); // <-- technically this is where it gets bad :)
	
	return 0;
}

